%add_findprov_lib_path %_libdir/beagle
%define ver_major 0.3

%def_disable epiphany
%define epiphany_ver 2.30
%def_enable xss
%def_enable thunderbird
%def_enable googlebackends
%def_enable evolution
%def_enable gui
%def_enable docs
%def_enable avahi
%def_disable qt

Name: beagle
Version: %ver_major.9
Release: alt8
Summary: The Beagle Search Infrastructure
Group: Graphical desktop/GNOME
License: %mit %asl %bsd %lgpl2plus
Packager: Alexey Shabalin <shaba@altlinux.ru>
Url: http://beagle-project.org/
Source0: ftp://ftp.gnome.org/pub/gnome/sources/%name/%ver_major/%name-%version.tar

# Working Epiphany Backend. 
# http://browser-extension-for-beagle.googlecode.com/svn/trunk/py-epiphany-extension/ 
Source1: beagleIndexer.conf.sample
Source2: beagleIndexer.ephy-extension
Source3: beagleIndexer.py

Patch0: %name-%version-%release.patch

# workaround - need for f-sport
Provides: mono(Beagle) = 0.0.0.0

# From configure.in 
%define mono_ver 1.9
%define monodoc_ver 1.2.4
%define ndesk_dbus_ver 0.5.2
%define ndesk_dbus_glib_ver 0.3.0
%define gtk_sharp_ver 2.10.0
%define gmime_sharp_ver 2.3.5
%define evolution_sharp_ver 0.13.3
%define gsf_sharp_ver 0.6
%define gtk_ver 2.10.0
%define avahi_sharp_ver 0.6.10
%define libexif_ver 0.5.7
%define taglib_sharp_ver 2.0
%define galago_sharp_ver 0.5

BuildPreReq: intltool >= 0.35.0
BuildPreReq: mono >= %mono_ver libmono-devel >= %mono_ver mono-devel >= %mono_ver
BuildPreReq: libgtk+2-devel >= %gtk_ver
BuildPreReq: libgtk-sharp2-devel  >= %gtk_sharp_ver
BuildPreReq: libgtk-sharp2-gapi
BuildPreReq: libgmime-sharp-devel >= %gmime_sharp_ver
BuildPreReq: libgsf-sharp-devel >= %gsf_sharp_ver
BuildPreReq: libgsf-devel
BuildPreReq: libgnome-sharp-devel >= %gtk_sharp_ver
BuildPreReq: librsvg-devel
BuildPreReq: libexif-devel >= %libexif_ver
BuildPreReq: libtag-sharp-devel >= %taglib_sharp_ver
BuildPreReq: libgalago-sharp-devel >= %galago_sharp_ver
BuildPreReq: ndesk-dbus-glib-devel >= %ndesk_dbus_glib_ver 
BuildPreReq: ndesk-dbus-devel >= %ndesk_dbus_ver
BuildPreReq: mono-data-sqlite mono-data mono-web-devel
BuildPreReq: libsqlite3-devel >= 3.3.9
%{?_enable_xss:BuildPreReq: xorg-x11-proto-devel libSM-devel libXScrnSaver-devel}
BuildPreReq: gnome-vfs-devel libgnome-devel
BuildPreReq: libatk-devel >= 1.2.4
BuildPreReq: libwv-devel
%{?_enable_avahi:BuildPreReq: libavahi-sharp-devel >= %avahi_sharp_ver}
BuildPreReq: kdelibs
BuildPreReq: libchm-devel
BuildPreReq: glibc-devel
%{?_enable_qt:BuildPreReq: qyoto >= 4.3.0}

Requires: sqlite3 zip unzip sed grep

# open file and uri over xdg-open
BuildRequires: xdg-utils
Requires: xdg-utils

BuildRequires: gcc-c++ glibc-devel imake xorg-cf-files  libSM-devel perl-XML-Parser
BuildRequires: gtk-doc zip 
BuildPreReq: rpm-build-mono >= 1.3 mono-mcs
BuildPreReq: rpm-build-licenses desktop-file-utils
BuildRequires: /proc

PreReq: shadow-utils

%description
A general infrastructure for making your data easy to find.

%package devel
Summary: Development files %name
Group: Development/Other
Requires: %name = %version-%release

%description devel
This package includes development files for the %name.


%if_enabled gui
%package gui
Summary: Beagle search system user interface
Group: Graphical desktop/GNOME
Requires: beagle = %version-%release

%description gui
User interface for doing beagle searches
%endif

%if_enabled evolution
%package evolution
Summary: Beagle backend for evolution
Group: Graphical desktop/GNOME
Requires: %name-gui = %version-%release
Requires: libevolution-sharp 

BuildPreReq: libevolution-sharp-devel >= %evolution_sharp_ver 

%description evolution
Beagle indexing backend for evolution
%endif

%if_enabled epiphany
%package -n epiphany-extension-%name
Summary: Epiphany extension for Beagle
Group: Networking/WWW
Requires: beagle = %version-%release
Requires: epiphany-extensions
BuildRequires: epiphany-devel epiphany-extensions

%description -n epiphany-extension-%name
This is an Epiphany extension that allows Beagle to index every page
the user views.  The code is derived from Dashboard's extension.

Right now, this extension is just a hack: for every page, Epiphany tries to
run a program named 'beagle-epiphany-index'.  The page's URI and title are
passed to beagle-epiphany-index as command-line arguments, and the HTML is
written to its stdin.

Obviously this opens up a huge security hole: anyone who can get a rogue
program named 'beagle-epiphany-index' into the user's path can spy on all of
their web traffic.

There is also the issue of private information (account numbers, etc.) ending
up in the index.  To try to avoid this, beagle-epiphany-index will not index
https:// URIs.
%endif

%package crawl-system
Group: System/Servers
Summary: Indexing subsystem for system files
Requires: %name = %version

%description crawl-system
Beagle is an indexing sub-system and search aggregator built on top of
Lucene.Net.
Install this to automatically index your system files.

%if_enabled docs
%package doc
Summary: Development documentation for %name
Group: Documentation
Provides: %name-monodoc = %version-%release
Obsoletes: %name-monodoc 
BuildPreReq: monodoc-devel >= %monodoc_ver
Requires: monodoc
BuildArch: noarch

%description doc
This package contains the API documentation for %name in Monodoc format.
%endif

%prep
%setup -q
%patch0 -p1

# in ALTLinux libchm wasn't change soname
%__subst 's|libchm.so.1|libchm.so.0|g' Util/ChmFile.cs
# fix libgnome-desktop-2.26
%__subst 's|libgnome-desktop-2.so.2|libgnome-desktop-2.so.17|g' search/Beagle.Search.exe.config
# fix path to libbeagleglue for x86_64
%__subst "s|/usr/lib/beagle/libbeagleglue.so.0|%_libdir/beagle/libbeagleglue.so.0|g" Util/Util.dll.config

%build
%autoreconf
%configure \
	--disable-static \
%if_enabled epiphany
	--enable-epiphany-extension \
	--enable-epiphany-extension-install \
%endif
	%{subst_enable evolution} \
	%{subst_enable xss} \
	%{subst_enable thunderbird} \
	%{subst_enable googlebackends} \
	%{subst_enable gui} \
	%{subst_enable docs} \
	%{subst_enable avahi} \
	%{subst_enable qt} \
	--localstatedir=%_var
%_make_bin clean
%make_build

%install
export GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL=1
%make_install install DESTDIR=%buildroot
unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL


mkdir -p %buildroot/var/cache/beagle/indexes

desktop-file-install --vendor gnome --delete-original		\
  --dir %buildroot%_datadir/applications			\
  --remove-category="Application" 				\
  --add-category="System" 					\
  %buildroot%_datadir/applications/beagle-search.desktop

desktop-file-install --vendor gnome --delete-original		\
  --dir %buildroot%_datadir/applications			\
  --remove-category="Application" 				\
  --remove-category="X-Ximian-Settings"				\
  --remove-category="AdvancedSettings"				\
  --add-category="DesktopSettings;GNOME"			\
  --remove-category Utility                                     \
  %buildroot%_datadir/applications/beagle-settings.desktop

# echo "NoDisplay=true" >> %buildroot%_datadir/applications/gnome-beagle-search.desktop
# %__sed -i -e 's@Icon=tango-system-search@Icon=gnome-search-tool@' %buildroot%_datadir/applications/gnome-beagle-search.desktop

%find_lang --with-gnome %name

rm -f %buildroot%_libdir/beagle/*.{a,la}
rm -f %buildroot%_libdir/gtk-2.0/*/filesystems/*.{a,la}
rm -f %buildroot%_libdir/*.{a,la}
rm -f %buildroot%_libdir/python*/site-packages/*.{a,la}

%if_enabled epiphany
mkdir -p %buildroot%_libdir/epiphany/%epiphany_ver/extensions
cp %SOURCE1 %buildroot%_libdir/epiphany/%epiphany_ver/extensions
%endif

%pre
%_sbindir/useradd -r -n -d /var/cache/beagle -c "User for Beagle indexing" -s /sbin/nologin beagleindex 2>/dev/null ||:

%files -f %name.lang
%doc COPYING README NEWS AUTHORS ChangeLog
%config(noreplace) %_sysconfdir/xdg/autostart/beagled-autostart.desktop
%dir %_sysconfdir/beagle
%dir %_sysconfdir/beagle/config-files
%config(noreplace) %_sysconfdir/beagle/config-files/*
%config(noreplace) %_sysconfdir/beagle/external-filters.xml.sample
%config(noreplace) %_sysconfdir/beagle/query-mapping.xml
%_bindir/beagle-config
%_bindir/beagled
%_bindir/beagle-extract-content
%_bindir/beagle-doc-extractor
%_bindir/beagle-index-info
%_bindir/beagle-info
%_bindir/beagle-ping
%_bindir/beagle-query
%_bindir/beagle-static-query
%_bindir/beagle-shutdown
%_bindir/beagle-status
%_sbindir/*
%dir %_libdir/%name
%dir %_libdir/%name/Filters
%dir %_libdir/%name/Backends
%_libdir/%name/BeagleDaemonLib.dll*
%_libdir/%name/BeagleDaemonPlugins.dll*
%_libdir/%name/Beagle.dll*
%_libdir/%name/Util.dll*
%_libdir/%name/BeagleDaemon.exe*
%_libdir/%name/BuildIndex.exe*
%_libdir/%name/Config.exe*
%_libdir/%name/ExtractContent.exe*
%_libdir/%name/DocExtractor.exe*
%_libdir/%name/DumpIndex.exe*
%_libdir/%name/IndexHelper.exe*
%_libdir/%name/Info.exe*
%_libdir/%name/ManageIndex.exe*
%_libdir/%name/Query.exe*
%_libdir/%name/StaticQuery.exe*
%_libdir/%name/Shutdown.exe*
%_libdir/%name/RemovableIndex.exe*
%_libdir/%name/beagled-index-helper
%_libdir/%name/libbeagleglue*
%_libdir/%name/keygrabber*
%_libdir/%name/Filters/*

%if_enabled thunderbird
%_libdir/beagle/Backends/ThunderbirdBackends.dll*
%endif

%if_enabled googlebackends
%_libdir/beagle/Backends/GoogleBackends.dll*
%endif


%_datadir/beagle
%_man1dir/*
%_man8dir/*

%files devel
%_pkgconfigdir/*

%files gui
%_bindir/beagle-imlogviewer
%_bindir/beagle-search
%_bindir/beagle-settings
%_libdir/%name/UiUtil.dll*
%_libdir/%name/ImLogViewer.exe*
%_libdir/%name/Beagle.Search.exe*
%_libdir/%name/Settings.exe*
%_libdir/%name/libbeagleuiglue*
%_datadir/applications/*
# %_datadir/gnome/autostart/*.desktop
#config(noreplace) %_sysconfdir/xdg/autostart/beagle-search-autostart.desktop


%files evolution
%_libdir/beagle/Backends/EvolutionBackends.dll*

%if_enabled epiphany
%files -n epiphany-extension-%name
%_libdir/epiphany/%epiphany_ver/extensions/*
%endif

%files crawl-system
%config(noreplace) %_sysconfdir/beagle/crawl*
%config(noreplace) %_sysconfdir/cron.daily/beagle-crawl-system
#%_libexecdir/beagle-crawl-system 
%dir %attr(755,beagleindex,root) %_var/cache/beagle
%dir %attr(755,beagleindex,root) %_var/cache/beagle/indexes
# blocale
%config(noreplace) %_sysconfdir/beagle/blocate.conf
%_bindir/blocate

%if_enabled docs
%files doc
%_monodocdir/beagle-docs.*
%endif

%exclude %_sysconfdir/xdg/autostart/beagle-search-autostart.desktop

%changelog
* Wed Apr 07 2010 Alexey Shabalin <shaba@altlinux.ru> 0.3.9-alt8
- rebuild with new taglib-sharp

* Sat Apr 03 2010 Alexey Shabalin <shaba@altlinux.ru> 0.3.9-alt7
- rebuild with libgnome-desktop-2.so.17

* Wed Mar 10 2010 Alexey Shabalin <shaba@altlinux.ru> 0.3.9-alt6
- git snaphot 1503db5d4df7328338e1b02d7fe306c6c7b3588b

* Wed Feb 10 2010 Alexey Shabalin <shaba@altlinux.ru> 0.3.9-alt5
- git snaphot 59f63233908b8ccee70251f698351014546d5765
- disable epiphany extension

* Tue Dec 01 2009 Eugeny A. Rostovtsev (REAL) <real at altlinux.org> 0.3.9-alt4.1
- Rebuilt with python 2.6

* Fri Jul 10 2009 Alexey Shabalin <shaba@altlinux.ru> 0.3.9-alt4
- update buildreq
- fix patch to libbeagleglue for x86_64
- move pkgconfig files from main to devel package

* Tue Jun 09 2009 Alexey Shabalin <shaba@altlinux.ru> 0.3.9-alt3
- rebuild with taglib-sharp-2.0.3.2

* Thu Mar 19 2009 Yuri N. Sedunov <aris@altlinux.org> 0.3.9-alt2
- fix build with epiphany-2.26
- shaba@:
    build for libgnome-desktop-2.26

* Wed Jan 28 2009 Alexey Shabalin <shaba@altlinux.ru> 0.3.9-alt1
- 0.3.9
- removed unneeded patches

* Wed Nov 26 2008 Alexey Shabalin <shaba@altlinux.ru> 0.3.8-alt4
- rebuild (and fix build) with new macros _monodocdir
- remove post scripts
- rename package %name-monodoc to %name-doc
- fix ddlmaps for Util (patch2)

* Thu Nov 20 2008 Alexey Shabalin <shaba@altlinux.ru> 0.3.8-alt3
- rebuild with libtag-sharp-2.0.3.0

* Mon Oct 20 2008 Alexey Shabalin <shaba@altlinux.ru> 0.3.8-alt2
- rebuild with new gmime-sharp
- Use sys/inotify.h (in glibc since 2.4) instead of our local copy. (GNOME #553159)
- fix build with gmime-2.4
- fix build with epiphany-2.24
- fix for libgnome-desktop-2.so.7

* Tue Jul 29 2008 Alexey Shabalin <shaba@altlinux.ru> 0.3.8-alt1
- 0.3.8
- fix display applications (GNOME #544607)

* Sat May 03 2008 Alexey Shabalin <shaba@altlinux.ru> 0.3.7-alt1
- 0.3.7

* Tue Apr 22 2008 Alexey Shabalin <shaba@altlinux.ru> 0.3.6.1-alt1
- 0.3.6.1
- Add a GMail and Google Apps email live search backend
- Add a 'locate' based backend to supplement the FileSystem backend

* Thu Apr 10 2008 Igor Vlasenko <viy@altlinux.ru> 0.3.5-alt1.qa1
- NMU (by repocop): the following fixes applied:
 * update_menus for beagle-gui

* Wed Apr 02 2008 Alexey Shabalin <shaba@altlinux.ru> 0.3.5-alt1
- 0.3.5
- install epiphany extension from main source (not from external)

* Mon Mar 24 2008 Alexey Shabalin <shaba@altlinux.ru> 0.3.4-alt1
- 0.3.4
- external source for epiphany extension

* Fri Feb 08 2008 Alexey Shabalin <shaba@altlinux.ru> 0.3.3-alt2
- move config files to main package (#14338)
- rediff and enable patch3 (log-level-warn)

* Mon Feb 04 2008 Alexey Shabalin <shaba@altlinux.ru> 0.3.3-alt1
- 0.3.3
- drop patch6:beagle-xdgmime-reload-crash.patch (fix in upstream)
- update patch12 - no autostart beagle-search

* Fri Jan 18 2008 Alexey Shabalin <shaba@altlinux.ru> 0.3.2-alt2
- add Provides: mono(Beagle) - need for f-spot

* Wed Jan 09 2008 Alexey Shabalin <shaba@altlinux.ru> 0.3.2-alt1.2
- rebuild for x86_64 (with fixed avahi-sharp)

* Thu Jan 03 2008 Alexey Shabalin <shaba@altlinux.ru> 0.3.2-alt1.1
- rebuild for x86_64 (with fixed ndesk-dbus)

* Fri Dec 28 2007 Alexey Shabalin <shaba@altlinux.ru> 0.3.2-alt1
- 0.3.2
- fix building with mono 1.2.6
- temporary disabled patch3 (log-level-warn)
- build with avahi-sharp

* Sun Dec 16 2007 Alexey Shabalin <shaba@altlinux.ru> 0.3.1-alt1
- 0.3.1
- Drop our Images.dll assembly and load all icons from the icon theme and stock icons.

* Thu Dec 06 2007 Alexey Shabalin <shaba@altlinux.ru> 0.3.0-alt1
- 0.3.0
- drop patches:
  + beagle-no-index-on-battery.patch (in upstream)
  + beagle-firefox-makefile.patch
  + beagle-0.2.16.2-fix-epiphany-2.20.patch (fix in upstream)
  + beagle-fix-desktopfiles.patch (in upstream)
- drop python and libbeagle packages
- update section %%files
- add package monodoc
- temporarily disable epiphany package(need fix makefile)
- change in Util/ChmFile.cs libchm.so.1 to libchm.so.0

* Mon Nov 26 2007 Alexey Shabalin <shaba@altlinux.ru> 0.2.18-alt2
- fix build with epiphany-2.20
- enable build Thunderbird backend
- disable autostart beagle-search - use gnome search applet

* Tue Sep 11 2007 Alexey Shabalin <shaba@altlinux.ru> 0.2.18-alt1
- 0.2.18

* Sat Jun 02 2007 Alexey Shabalin <shaba@altlinux.ru> 0.2.17-alt1
- 0.2.17

* Mon Apr 02 2007 Alexey Shabalin <shaba@altlinux.ru> 0.2.16.3-alt1
- 0.2.16.3
- fix build with epiphany 2.18
- remove beagle-0.2.10-xconnection-exit.patch (in upstream)

* Mon Mar 05 2007 Alexey Shabalin <shaba@altlinux.ru> 0.2.16-alt2
- rebuild with new wv-1.2.4

* Tue Feb 13 2007 Alexey Shabalin <shaba@altlinux.ru> 0.2.16-alt1
- 0.2.16

* Thu Feb 01 2007 Alexey Shabalin <shaba@altlinux.ru> 0.2.15.1-alt1
- 0.2.15.1
- disable build broken Thunderbird backend

* Fri Dec 15 2006 Alexey Shabalin <shaba@altlinux.ru> 0.2.14-alt1
- 0.2.14
- use included autostart desktop entries in /etc/xdg/autostart
- move autostart beagled in beagle package
- remove SOURCE1 and SOURCE2 (desktop files)
- add crawl-system package
- update beagle-crawl-config.patch and beagle-log-level-warn.patch
- noreplace for config files in /etc
- add gtk-doc in libbegle-devel
- add in BuildRequires libchm-devel
- add "make clean" in build section (bad source beagle tar.bz2)

* Thu Dec 14 2006 Alexey Shabalin <shaba@altlinux.ru> 0.2.13-alt1
- move autostart to beagle-gui
- move autostart beagled from /etc/xdg/autostart to /usr/share/gnome/autostart 
  for KDE use "kerry"
- add autostart beagle-search tray icon
- cleanup spec

* Tue Oct 31 2006 Alexey Shabalin <shaba@altlinux.ru> 0.2.13-alt0.1
- first build for ALT Linux.
- adaptation spec from RH
- build firefox extension from another source package
